<?php
//********************************************************************
//* Piccy-Cabinet                                                    *
//* Copyright (c) Album-System All rights Reserved.                  *
//* url:http://www.album-system.com/                                 *
//* e-mail:webmaster@album-system.com                                *
//* Create：2007-03-01(Bata1)                                        *
//* Update：2007-06-10(Bata2)                                        *
//* Update：2007-06-30(0.1.00)                                       *
//* Update：2007-07-15(0.1.01)                                       *
//********************************************************************
//================================================================

//コンフィグファイル読み込み
require_once("config_common.php");
//SQLモジュール読み込み
require_once("db_common.php");
//ログモジュール読み込み
require_once("logger.php");
//共通関数モジュール読み込み
require_once("common.php");
//PEARライブラリ読み込み
require_once("XML/Serializer.php");

session_name(AUTH_SESSION_NAME);

function set_response_status($code){
	global $XmlArray;
	
	$response[1000]["status"] = "SUCCESS";
	$response[1000]["code"] = 1000;
	$response[1000]["message"] = "XML I/Fの処理は成功しました。";
	
	$response[9900]["status"] = "ERROR";
	$response[9900]["code"] = 9900;
	$response[9900]["message"] = "DBのアクセスに失敗しました。";
	
	$response[9901]["status"] = "ERROR";
	$response[9901]["code"] = 9901;
	$response[9901]["message"] = "アクセス権不正処理が行われました。";
	
	$response[9902]["status"] = "ERROR";
	$response[9902]["code"] = 9902;
	$response[9902]["message"] = "XML-APIへのパラメタが不正です。";
	
	$response[9903]["status"] = "ERROR";
	$response[9903]["code"] = 9903;
	$response[9903]["message"] = "アクセス時のパラメタが不足しています。";
	
	$response[9904]["status"] = "ERROR";
	$response[9904]["code"] = 9904;
	$response[9904]["message"] = "認証エラーです。認証が行われていないか、タイムアウトしています。再度ログインして下さい。";
	
	$response[9905]["status"] = "ERROR";
	$response[9905]["code"] = 9905;
	$response[9905]["message"] = "アルバム作成処理エラーです。";
	
	$response[9906]["status"] = "ERROR";
	$response[9906]["code"] = 9906;
	$response[9906]["message"] = "既に登録されているアルバム名です。別のアルバム名を指定して下さい。";
	
	$response[9907]["status"] = "ERROR";
	$response[9907]["code"] = 9907;
	$response[9907]["message"] = "アルバムダウンロード処理が失敗しました。";
	
	$response[9908]["status"] = "ERROR";
	$response[9908]["code"] = 9908;
	$response[9908]["message"] = "ログイン失敗。";

	
	$response[9999]["status"] = "ERROR";
	$response[9999]["code"] = 9999;
	$response[9999]["message"] = "XML-APIの内部エラーです。";
	
	log_message(9000,"set_response_status response=".print_r($response[$code], True));
	
	$response_array["status"] = cnv_apistr($response[$code]["status"]);
	$response_array["code"] = cnv_apistr($response[$code]["code"]);
	$response_array["message"] = cnv_apistr($response[$code]["message"]);
	$XmlArray["ResponseStatus"] = $response_array;
}

function send_xml_response(){
	global $XmlArray;
	
	$params = array(
	  XML_SERIALIZER_OPTION_INDENT => "\t",
	  XML_SERIALIZER_OPTION_XML_ENCODING => 'UTF-8',
	  XML_SERIALIZER_OPTION_XML_DECL_ENABLED => TRUE,
	  XML_SERIALIZER_OPTION_ROOT_NAME => 'piccy_cabinet',
	  XML_SERIALIZER_OPTION_ROOT_ATTRIBS => array('version' => '0.0.1'),
	  XML_SERIALIZER_OPTION_DEFAULT_TAG => 'item'
	); 
	$xml = new XML_Serializer($params);
	
	$xml->serialize($XmlArray);
	
	header("Content-Type: text/xml; charset=utf-8"); 
	echo $xml->getSerializedData();
}

function get_user_info(){
	global $XmlArray;
	global $GetArray;
	global $AuthObj;
	
	$res = db_select_user_id($AuthObj->getAuthData("user_id"));
	if(!$res){
		log_message(9000,"function(go_change_access) DBセレクトで失敗");
		error_exit(9900);
	}
	$user_val = cnv_apiarray($res);
	set_response_status(1000);
	$XmlArray["UserInfo"] = $user_val[0];
	send_xml_response();
	$res->free();
}		
			
function get_cat_list(){
	global $AuthObj;
	global $XmlArray;
	
	if(!strcmp($AuthObj->getAuthData("user_auth"),"ADMIN")){
		$res = db_select_cat();
		if(!$res){
			log_message(9000,"function:get_cat_list: DBセレクトで失敗");
			error_exit(9900);
		}
	}else{
		$res = db_select_cat_access_user_id($AuthObj->getAuthData("user_id"));
		if(!$res){
			log_message(9000,"function:get_cat_list DBセレクトで失敗");
			error_exit(9900);
		}
	}
	set_response_status(1000);
	$XmlArray["CatList"] = cnv_apiarray($res);
	send_xml_response();
	$res->free();
}

function get_cat_val(){
	global $XmlArray;
	global $GetArray;
	
	$res = db_select_cat_id($GetArray["cat_id"]);
	if(!$res){
		log_message(9000,"function(disp_album) DBセレクトで失敗");
		error_exit(9900);
	}
	$cat_val = cnv_apiarray($res);
	set_response_status(1000);
	$XmlArray["CatVal"] = $cat_val[0];
	send_xml_response();
	$res->free();
}

function get_album_list(){
	global $XmlArray;
	global $GetArray;
	
	$res = db_select_album_list($GetArray["cat_id"]);
	if(!$res){
		log_message(9000,"function(disp_album) DBセレクトで失敗");
		error_exit(9900);
	}
	set_response_status(1000);
	$XmlArray["AlbumList"] = cnv_apiarray($res);
	send_xml_response();
	$res->free();
}

function get_album_val(){
	global $XmlArray;
	global $GetArray;
	
	$res = db_select_album_id($GetArray["cat_id"],  $GetArray["album_id"]);
	if(!$res){
		log_message(9000,"function(disp_album) DBセレクトで失敗");
		error_exit(9900);
	}
	$album_val = cnv_apiarray($res);
	set_response_status(1000);
	$XmlArray["AlbumVal"] = $album_val[0];
	send_xml_response();
	$res->free();
}

function get_photo_list(){
	global $XmlArray;
	global $GetArray;
	
	$res = db_select_photo($GetArray["cat_id"],$GetArray["album_id"]);
	if(!$res){
		log_message(9000,"function(show_thumb) DBセレクトで失敗");
		error_exit(9900);
	}
	set_response_status(1000);
	$XmlArray["PhotoList"] = cnv_apiarray($res);
	send_xml_response();
	$res->free();
}

function get_photo_val_api(){
	global $XmlArray;
	global $GetArray;
	
	$res = db_select_photo_id($GetArray["cat_id"], $GetArray["album_id"], $GetArray["photo_id"]);
	if(!$res){
		log_message(9000,"function(disp_photo) DBセレクトで失敗");
		error_exit(9900);
	}
	$photo_val = cnv_apiarray($res);
	set_response_status(1000);
	$XmlArray["PhotoVal"] = $photo_val[0];
	send_xml_response();
	$res->free();
}

function get_image(){
	global $GetArray;
	global $ConfigArray;
	
	$res = db_select_photo_id($GetArray["cat_id"], $GetArray["album_id"], $GetArray["photo_id"]);
	if(!$res){
		log_message(9000,"function(disp_photo) DBセレクトで失敗");
		error_exit(9900);
	}
	
	$album_array = cnv_disparray($res);
	
	switch ($GetArray["type"]) {
		case "thumb1":
			$photo_path = $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$GetArray["cat_id"]."_".$GetArray["album_id"]."/".THUMB1_DIR_NAME."/".$album_array[0]['photo_name'];
			$fp = fopen($photo_path, "r");
			$photo_binary = fread($fp, filesize($photo_path));
			fclose($fp);
			
			header("Content-type: ".$album_array[0]["photo_mime_type"]);
			echo $photo_binary;
			$res->free();
			break;
		case "thumb2":
			$photo_path = $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$GetArray["cat_id"]."_".$GetArray["album_id"]."/".THUMB2_DIR_NAME."/".$album_array[0]['photo_name'];
			$fp = fopen($photo_path, "r");
			$photo_binary = fread($fp, filesize($photo_path));
			fclose($fp);
			
			header("Content-type: ".$album_array[0]["photo_mime_type"]);
			echo $photo_binary;
			$res->free();
			break;
		case "thumb3":
			$photo_path = $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$GetArray["cat_id"]."_".$GetArray["album_id"]."/".THUMB3_DIR_NAME."/".$album_array[0]['photo_name'];
			$fp = fopen($photo_path, "r");
			$photo_binary = fread($fp, filesize($photo_path));
			fclose($fp);
			
			header("Content-type: ".$album_array[0]["photo_mime_type"]);
			echo $photo_binary;
			$res->free();
			break;
		case "thumb4":
			$photo_path = $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$GetArray["cat_id"]."_".$GetArray["album_id"]."/".THUMB4_DIR_NAME."/".$album_array[0]['photo_name'];
			$fp = fopen($photo_path, "r");
			$photo_binary = fread($fp, filesize($photo_path));
			fclose($fp);
			
			header("Content-type: ".$album_array[0]["photo_mime_type"]);
			echo $photo_binary;
			$res->free();
			break;
		case "original":
			$photo_path = $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$GetArray["cat_id"]."_".$GetArray["album_id"]."/".ORIGINAL_DIR_NAME."/".$album_array[0]['photo_name'];
			$fp = fopen($photo_path, "r");
			$photo_binary = fread($fp, filesize($photo_path));
			fclose($fp);
			
			header("Content-type: ".$album_array[0]["photo_mime_type"]);
			echo $photo_binary;
			$res->free();
			break;
		default:
			log_message(9902,"type=".$GetArray["type"]);
			error_exit(9902);
	}
}

function get_album_info(){
	global $XmlArray;
	global $ConfigArray;
	
	$album_info["AlbumName"] = cnv_apistr($ConfigArray["root"]["album_config"]["COMMON"]["album_name"]);
	$album_info["DefaultTemplate"] = $ConfigArray["root"]["album_config"]["COMMON"]["default_template"];
	$album_info["Thumb1Policy"] = $ConfigArray["root"]["album_config"]["PHOTO"]["thumb1_policy"];
	$album_info["Thumb1Height"] = $ConfigArray["root"]["album_config"]["PHOTO"]["thumb1_height"];
	$album_info["Thumb1Width"] = $ConfigArray["root"]["album_config"]["PHOTO"]["thumb1_width"];
	$album_info["Thumb1CompRate"] = $ConfigArray["root"]["album_config"]["PHOTO"]["thumb1_comp_rate"];
	$album_info["Thumb2Policy"] = $ConfigArray["root"]["album_config"]["PHOTO"]["thumb2_policy"];
	$album_info["Thumb2Height"] = $ConfigArray["root"]["album_config"]["PHOTO"]["thumb2_height"];
	$album_info["Thumb2Width"] = $ConfigArray["root"]["album_config"]["PHOTO"]["thumb2_width"];
	$album_info["Thumb2CompRate"] = $ConfigArray["root"]["album_config"]["PHOTO"]["thumb2_comp_rate"];
	$album_info["LogFileName"] = $ConfigArray["root"]["album_config"]["LOG"]["name"];
	$album_info["LogLevel"] = $ConfigArray["root"]["album_config"]["LOG"]["level"];
	$album_info["LogFileNum"] = $ConfigArray["root"]["album_config"]["LOG"]["num"];
	$album_info["LogFileSize"] = $ConfigArray["root"]["album_config"]["LOG"]["size"];

	set_response_status(1000);
	$XmlArray["AlbumInfo"] = $album_info;
	send_xml_response();
}		

function exec_add_album_zip_step1(){
	global $XmlArray;
	global $PostArray;
	global $ConfigArray;
	global $AuthObj;
	
	log_message(9000,"function(exec_add_album_zip_step1) START");
	
	//入力チェック
	if($PostArray["album_name"] == ""){
		log_message(3100,"アルバム名=".$PostArray["album_name"]);
		error_exit(9905);
	}
	
	//入力チェック
	if($PostArray["cat_id"] == NULL){
		log_message(3101,"アルバム名=".$PostArray["album_name"]." cat_id=".$PostArray["cat_id"]);
		error_exit(9905);
	}
	
	//既に同名のアルバムが存在しないかチェック
	if(is_album_name_in_cat($PostArray["cat_id"],$PostArray["album_name"])){
		error_exit(9906);
	}
	
	log_message(9000,"function(exec_add_album_zip_step1) アルバム作成処理開始！！");
	//アルバムリストに新規アルバムレコード追加
	$res = db_insert_album_list($PostArray["cat_id"],
			$PostArray["album_name"],$PostArray["album_comment"], 
			$AuthObj->getAuthData("user_id"), 10, 0, 0, 0, now_time(), now_time());
	if(!$res){
		log_message(3102,"アルバム名=".$PostArray["album_name"]);
		error_exit(9905);
	}
	
	log_message(9000,"function(exec_add_album_zip_step1) 写真用テーブル作成処理開始！！");	
	//写真用テーブル作成
	$res = db_select_album_name($PostArray["cat_id"], $PostArray["album_name"]);
	if(!$res){
		log_message(3102,"アルバム名=".$PostArray["album_name"]);
		db_del_album_name($PostArray["cat_id"], $PostArray["album_name"]);
		error_exit(9905);
	}
	$cat_row = $res->fetchRow(DB_FETCHMODE_ASSOC);
	$res = db_create_photo_table($PostArray["cat_id"], $cat_row["album_id"]);
	if(!$res){
		log_message(3102,"アルバム名=".$PostArray["album_name"]);
		db_del_album_name($PostArray["cat_id"], $PostArray["album_name"]);
		error_exit(9905);
	}
	
	//フォルダ作成
	$target_basedir = $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$PostArray["cat_id"]."_".$cat_row["album_id"];
	if(!create_dir($target_basedir)){
		log_message(3103,"dir=".$target_basedir);
		error_exit(9905);
	}
		
	$zip_file_name = date("Y-m-d-H-i-s").".zip";
	
	$ret["cat_id"] = $PostArray["cat_id"];	
	$ret["album_id"] = $cat_row["album_id"];
	$ret["zip_file_name"] = $zip_file_name;
	
	set_response_status(1000);
	$XmlArray["Ret"] = $ret;
	send_xml_response();
	
	log_message(9000,"アルバム作成処理Step1終了　アルバム名=".$PostArray["album_name"]);
	//disp_album_manage("add_album_zip");
}

function exec_add_album_zip_step2(){
	global $PostArray;
	global $ConfigArray;
	
	//ZIPファイル確認処理
	$user_file_name = $_FILES['user_file']['name'];
	
	$path_parts = pathinfo($user_file_name);
	if(!(strcasecmp("ZIP",$path_parts["extension"]) == 0)){
		log_message(3104,"指定されたファイル名：".$path_parts["basename"]);
		error_exit(9905);
	}
	
	//log_message(9000,"$_FILES=".print_r($_FILES, true));
	
	set_time_limit ( 0 );	
	//ZIPファイルアップロード処理開始
	$zip_file_name = $PostArray["zip_file_name"];
	if(!get_user_file($PostArray["cat_id"]."_".$PostArray["album_id"], $zip_file_name, $_FILES["user_file"]["tmp_name"])){
		log_message(3104,"アルバム名=".$PostArray["album_name"]);
		error_exit(9905);
	}
	
	set_response_status(1000);
	send_xml_response();	
}

function exec_add_album_zip_step3(){
	global $PostArray;
	global $ConfigArray;
	global $AuthObj;
	
	set_time_limit ( 0 );
	//アルバム作成処理(非同期)
	
	$zip_file_name = $PostArray["zip_file_name"];
	$target_basedir = $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$PostArray["cat_id"]."_".$PostArray["album_id"];
	
	
	//0.1.01　同期処理追加
	if(!strcmp($ConfigArray["root"]["album_config"]["PHP"]["mod"],"Async")){
		//アルバム作成処理(非同期)
		$cmd = $ConfigArray["root"]["album_config"]["PHP"]["cmd"].
				" -f ".CREATE_ALBUM_ZIP_PHP_FILE." ".$PostArray["cat_id"]." ".$PostArray["album_id"].
				" ".$zip_file_name." ".$AuthObj->getAuthData("user_id")." > ".
				$ConfigArray["root"]["album_config"]["PHP"]["nul"]." &";
		log_message(9000,"アルバム作成処理開始　cmd=".$cmd);
		$ret = null;
		system($cmd, $ret);
		log_message(9000,"system関数実行　ret=".$ret);
	}else{
		//アルバム作成処理(同期)
		if(!create_album_from_zip($PostArray["cat_id"], $PostArray["album_id"],
		$zip_file_name, $AuthObj->getAuthData("user_id"))){
			//error
			log_message(1067,"アルバム名=".$PostArray["album_name"]);
			delete_dir($target_basedir);
			db_del_album_name($PostArray["cat_id"], $PostArray["album_name"]);
			db_drop_photo_table($PostArray["cat_id"], $PostArray["album_id"]);
			error_exit(4);
		}	
	}
	log_message(3000,"カテゴリID_アルバムID=".$PostArray["cat_id"]."_".$PostArray["album_id"]);	
	
	set_response_status(1000);
	send_xml_response();
}

function exec_album_download_flash(){
	global $PostArray;
	global $ConfigArray;
	
	$photo_dir_name = $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$PostArray["cat_id"]."_".$PostArray["album_id"]."/".ORIGINAL_DIR_NAME;
	
	$photo_id_list = explode(",",$PostArray["download_file"]);
	
	foreach($photo_id_list as $k => $photo_id){
		//$k photo_id $v photo_file_name
		//ダウンロードカウントUP
		db_update_photo_download_count($PostArray["cat_id"], $PostArray["album_id"], $photo_id);
		$res = db_select_photo_id($PostArray["cat_id"], $PostArray["album_id"], $photo_id);
		if(!$res){
			log_message(9000,"function(disp_photo) DBセレクトで失敗");
			error_exit(9900);
		}
		$photo_val = cnv_apiarray($res);
		$photo_file_name = $photo_val[0]["photo_name"];
		//ファイルパス作成
		$photo_file_path_array[] = $photo_dir_name."/".$photo_file_name;
	}
	
	//PEAR　HTTP＿Download実行
	db_update_cat_download_count($PostArray["cat_id"]);
	db_update_album_list_download_count($PostArray["cat_id"], $PostArray["album_id"]);
	
	log_message(9000,"DOWNLOAD FILE".print_r($photo_file_path_array, True));
	//PEAR 読み込み
	require_once("HTTP/Download.php");
	$http_down = HTTP_Download::sendArchive("album.zip", $photo_file_path_array, HTTP_DOWNLOAD_ZIP,"" ,$photo_dir_name);
	
	if (PEAR::isError($http_down)) {
	    log_message(3105,"カテゴリID＝".$PostArray["cat_id"]." アルバムID=".$PostArray["album_id"]." ErrorMessage=$http_down->getMessage()");
	    //error_exit(9907);
	}else{
		log_message(3001,"カテゴリID＝".$PostArray["cat_id"]." アルバムID=".$PostArray["album_id"]);
	}
	
	//set_response_status(1000);
	//send_xml_response();
}

//メイン処理

//POST GETデータ変換
$GetArray = cnv_formstr($_GET);
$PostArray = cnv_formstr($_POST);

//DB接続
$Conn = db_conn();
if(!$Conn){
	log_message(9000,"function(db_conn) DB接続で失敗");
	error_exit(9900);
}

//認証なし特別処理
if(isset($PostArray["mod"]) && !strcmp($PostArray["mod"],"add_album_zip_step2")){
	log_message(9000,"add_album_zip_step2実行開始");
	exec_add_album_zip_step2();
	exit();	
}

//認証ロジック読み込み
require_once("album_auth.php");
$AuthObj = new Auth("DB", $params, "");
$AuthObj->setShowLogin(FALSE);
$AuthObj->start();

if($AuthObj->getAuth()){
	log_message(9000,"認証成功 user=".$AuthObj->getUsername());
}else{
	if(isset($PostArray["mod"])&&(!strcmp($PostArray["mod"],"login"))){
		log_message(3106,"username=".$PostArray["username"]." password=".$PostArray["password"]);
		error_exit(9908);
	}else{
		error_exit(9904);
	}
}

if(isset($GetArray["mod"])) {
	log_message(9000,"GET時処理開始");
	
	switch ($GetArray["mod"]) {	
		case "get_user_info":
			log_message(9000,"get_user_info処理開始");
			get_user_info();
			break;
			
		case "get_cat_list":
			//アクセス制御なし
			log_message(9000,"get_cat_list処理開始");
			get_cat_list();
			break;
			
		case "get_cat_val":
			if(!isset($GetArray["cat_id"])){
				error_exit(9903);
			}
			//not ADMINならば、アクセス制御ありCat　ADMINは、OK
			if(!check_cat_access($GetArray["cat_id"])){
				error_exit(9901);
			}
			log_message(9000,"get_cat_val処理開始");
			get_cat_val();
			break;
			
		case "get_album_list":
			if(!isset($GetArray["cat_id"])){
				error_exit(9903);
			}
			//not ADMINならば、アクセス制御ありCat　ADMINは、OK
			if(!check_cat_access($GetArray["cat_id"])){
				error_exit(9901);
			}
			log_message(9000,"get_album_list処理開始");
			get_album_list();
			break;
			
		case "get_album_val":
			if(!isset($GetArray["cat_id"]) or !isset($GetArray["album_id"])){
				error_exit(9903);
			}
			//not ADMINならば、アクセス制御ありCat　ADMINは、OK
			if(!check_cat_access($GetArray["cat_id"])){
				error_exit(9901);
			}
			log_message(9000,"get_album_val処理開始");
			get_album_val();
			break;

		case "get_photo_list":
			if(!isset($GetArray["cat_id"]) or !isset($GetArray["album_id"])){
				error_exit(9903);
			}
			//not ADMINならば、アクセス制御ありCat　ADMINは、OK
			if(!check_cat_access($GetArray["cat_id"])){
				error_exit(9901);
			} 
			log_message(9000,"get_photo_list処理開始");
			get_photo_list();
			break;
			
		case "get_photo_val":
			if(!isset($GetArray["cat_id"]) or !isset($GetArray["album_id"]) or !isset($GetArray["photo_id"])){
				error_exit(9903);
			}
			//not ADMINならば、アクセス制御ありCat　ADMINは、OK
			if(!check_cat_access($GetArray["cat_id"])){
				error_exit(9901);
			}
			log_message(9000,"get_photo_val処理開始");
			get_photo_val_api();
			break;
		
		case "get_image":
			if(!isset($GetArray["cat_id"]) or !isset($GetArray["album_id"]) or !isset($GetArray["photo_id"]) or !isset($GetArray["type"])){
				error_exit(9903);
			}
			//not ADMINならば、アクセス制御ありCat　ADMINは、OK
			if(!check_cat_access($GetArray["cat_id"])){
				error_exit(9901);
			}
			get_image();
			break;
			
		case "increase_cat_view_count":
			if(!isset($GetArray["cat_id"])){
				error_exit(9903);
			}
			//not ADMINならば、アクセス制御ありCat　ADMINは、OK
			if(!check_cat_access($GetArray["cat_id"])){
				error_exit(9901);
			}
			log_message(9000,"increase_cat_view_count処理開始");
			//カテゴリshowカウントUP
            db_update_cat_show_count($GetArray["cat_id"]);
			set_response_status(1000);
			send_xml_response();
			break;
			
		case "increase_album_view_count":
			if(!isset($GetArray["cat_id"]) or !isset($GetArray["album_id"])){
				error_exit(9903);
			}
			//not ADMINならば、アクセス制御ありCat　ADMINは、OK
			if(!check_cat_access($GetArray["cat_id"])){
				error_exit(9901);
			}
			log_message(9000,"increase_album_view_count処理開始");
			//アルバムshowカウントUP
            db_update_album_list_show_count($GetArray["cat_id"],$GetArray["album_id"]);
			set_response_status(1000);
			send_xml_response();
			break;
			
			
		case "increase_photo_view_count":
			if(!isset($GetArray["cat_id"]) or !isset($GetArray["album_id"]) or !isset($GetArray["photo_id"])){
				error_exit(9903);
			}
			//not ADMINならば、アクセス制御ありCat　ADMINは、OK
			if(!check_cat_access($GetArray["cat_id"])){
				error_exit(9901);
			}
			log_message(9000,"increase_photo_view_count処理開始");
			//photo showカウントUP
            db_update_photo_show_count($GetArray["cat_id"], $GetArray["album_id"], $GetArray["photo_id"]);
			set_response_status(1000);
			send_xml_response();
			break;
			
		case "logout":
			//アクセス制御なし
			log_message(9000,"logout処理開始");
			$AuthObj->logout();
			set_response_status(1000);
			send_xml_response();
			break;
			
		case "get_album_info":
			log_message(9000,"get_album_info処理開始");
			get_album_info();
			break;
		
		default:
			log_message(9902,"mod=".$GetArray["mod"]);
			error_exit(9902);
	}
}

if(isset($PostArray["mod"])){
	switch ($PostArray["mod"]) {
		case "login":
			log_message(9000,"login処理成功");
			set_response_status(1000);
			send_xml_response();
			break;
		case "add_album_zip_step1":
			//not ADMINならば、アクセス制御ありCat　ADMINは、OK　and not GUEST
			if(!check_cat_access_not_guest($PostArray["cat_id"])){
				error_exit(9903);
			}
			log_message(9000,"add_album_zip_step1処理開始");
			exec_add_album_zip_step1();
			break;
			
		case "add_album_zip_step2":
			//(予約)Step2は、アクセス認証なし処理
			break;
			
		case "add_album_zip_step3":
			//not ADMINならば、アクセス制御ありCat　ADMINは、OK　and not GUEST
			if(!check_cat_access_not_guest($PostArray["cat_id"])){
				error_exit(9903);
			}
			log_message(9000,"add_album_zip_step3処理開始");
			exec_add_album_zip_step3();
			break;
		
		case "exec_album_download_flash":
			if(!isset($PostArray["cat_id"]) or !isset($PostArray["album_id"])){
				error_exit(9903);
			}
			//not ADMINならば、アクセス制御ありCat　ADMINは、OK　and not GUEST
			if(!check_cat_access_not_guest($PostArray["cat_id"])){
				error_exit(9903);
			}
			log_message(9000,"exec_album_download_flash処理開始");
			exec_album_download_flash();
			break;
			
		default:
			log_message(9902,"mod=".$PostArray["mod"]);
			error_exit(9902);
	}
}

//error_exit関数
function error_exit($ret){
	log_message(9000,"function(error_exit) ret:".$ret);
	
	global $AuthObj;
	
	switch ($ret) {
		case 9900:
			log_message(9900,"");
			set_response_status(9900);
			break;
		case 9901:
			log_message(9901,"user=".$AuthObj->getUsername());
			set_response_status(9901);
			break;
		case 9902:
			set_response_status(9902);
			break;
		case 9903:
			set_response_status(9903);
			break;
		case 9904:
			set_response_status(9904);
			break;
		case 9905:
			set_response_status(9905);
			break;
		case 9906:
			set_response_status(9906);
			break;
		case 9907:
			set_response_status(9907);
			break;
		case 9908:
			set_response_status(9908);
			break;
		default:
			log_message(9999,"");
			set_response_status(9999);
	}

	send_xml_response();
	//DBコネクションクローズ
	db_close();
	shutdown_logger();
	exit();
}

//DBコネクションクローズ
db_close();
shutdown_logger();


?>