<?php
//********************************************************************
//* Piccy-Cabinet                                                    *
//* Copyright (c) Album-System All rights Reserved.                  *
//* url:http://www.album-system.com/                                 *
//* e-mail:webmaster@album-system.com                                *
//* Create：2007-03-01(Bata1)                                        *
//* Update：2007-06-10(Bata2)                                        *
//* Update：2007-06-30(0.1.00)                                       *
//* Update：2007-07-15(0.1.01)                                       *
//********************************************************************
//================================================================

//PEARライブラリ読み込み
require_once("Config.php");
//共通関数モジュール読み込み
//基本的に他モジュール読み込み禁止


//その他作成モジュールのinclude禁止(コンフィグ読み込み前に動作しない)
//バージョンファイル名
define("NOW_VERSION", "0.1.01");
//SESSION NAME
define("AUTH_SESSION_NAME", "album-system");

//defineコンフィグ内容記載
define("CONFIG_FILE_NAME","config.xml");
define("ENCDISP", "UTF-8");
define("ENCDB", "EUC-JP");
define("ENCAPI", "UTF-8");

//ユーザ初期設定
//テンプレートディレクトリのプレフィックス
define("TEMPLATE_PREFIX","tmpl");
//テンプレート名
$TemplateName["tmpl_basic"] = "標準ビュー(ベーシック)";
$TemplateName["tmpl_basic2"] = "標準ビュー(ポップ)";
$TemplateName["tmpl_basic3"] = "標準ビュー(キュート)";
$TemplateName["tmpl_basic4"] = "標準ビュー(ベーシック２)";
$TemplateName["tmpl_flex"] = "デザインビュー(Flex)";
$TemplateName["tmpl_flash"] = "デザインビュー(Flash)";
$TemplateName["tmpl_ajax"] = "デザインビュー(Ajax)";
$TemplateName["tmpl_simple"] = "シンプルビュー";

//デフォルトテンプレート
define("DEFALUT_TEMPLATE","tmpl_basic");
define("DEFALUT_CAT_SORT",1);
define("DEFALUT_ALBUM_SORT",1);
define("DEFALUT_PHOTO_SORT",0);
//ソート関係設定
$CatSortPolicy[0]["sql"] = "cat_id";
$CatSortPolicy[0]["type"] = 0;
$CatSortPolicy[0]["name"] = "カテゴリ作成降順";
$CatSortPolicy[0]["discription"] = "古く作成されたカテゴリ順に表示";
$CatSortPolicy[1]["sql"] = "cat_id DESC";
$CatSortPolicy[1]["type"] = 1;
$CatSortPolicy[1]["name"] = "カテゴリ作成昇順";
$CatSortPolicy[1]["discription"] = "新しく作成されたカテゴリ順に表示";

$AlbumSortPolicy[0]["sql"] = "album_id";
$AlbumSortPolicy[0]["type"] = 0;
$AlbumSortPolicy[0]["name"] = "アルバム作成降順";
$AlbumSortPolicy[0]["discription"] = "古く作成されたアルバム順に表示";
$AlbumSortPolicy[1]["sql"] = "album_id DESC";
$AlbumSortPolicy[1]["type"] = 1;
$AlbumSortPolicy[1]["name"] = "アルバム作成昇順";
$AlbumSortPolicy[1]["discription"] = "新しく作成されたアルバム順に表示";

$PhotoSortPolicy[0]["sql"] = "photo_id";
$PhotoSortPolicy[0]["type"] = 0;
$PhotoSortPolicy[0]["name"] = "写真作成降順";
$PhotoSortPolicy[0]["discription"] = "古く作成された写真順に表示";
$PhotoSortPolicy[1]["sql"] = "photo_id DESC";
$PhotoSortPolicy[1]["type"] = 1;
$PhotoSortPolicy[1]["name"] = "写真作成昇順";
$PhotoSortPolicy[1]["discription"] = "新しく作成された写真順に表示";

//各ページのヘッダー部分　(アクセス解析スクリプトなどを挿入して利用する)
define("TEMPLATE_HEADER","");
//各ページのフッター部分
define("TEMPLATE_FOOTER","");

//写真ファイル保存ファイル名
//オリジナルディレクトリ名
define("ORIGINAL_DIR_NAME","original");
//サムネイル１ディレクトリ名
define("THUMB1_DIR_NAME","thumb1");
//サムネイル２ディレクトリ名
define("THUMB2_DIR_NAME","thumb2");
//サムネイル１ディレクトリ名
define("THUMB3_DIR_NAME","thumb3");
//サムネイル２ディレクトリ名
define("THUMB4_DIR_NAME","thumb4");
//作業ディレクトリ名(ZIP解凍用)
define("WORK_DIR_NAME","work");

//ログ関係
define("LOG_DIR",log);
define("DEBUG", 1);
define("INFO", 2);
define("WARNING", 3);
define("ERROR", 4);
//ログ初期値
define("INITIAL_LOG_FILE_NAME","album");

//PHPファイル名(アルバム作成非同期処理用PHP)
define("CREATE_ALBUM_ZIP_PHP_FILE","create_album_zip.php");
//バージョンファイル名
define("VERSION_FILE", "./version.txt");

//アルバム管理画面表示時に表示するアルバム内写真の表示数
define("NUM_LIMIT_PHOTO",5);

//HTMLテンプレートライブラリ
define("TEMPLATE_LIB", "./lib/htmltemplate/htmltemplate.inc");
define("TEMPLATE_DIR", "./template");
//LOGIN,INFO,INITIALテンプレートは共通
define("TEMPLATE_LOGIN", TEMPLATE_DIR."/"."login.html");
define("TEMPLATE_INFO", TEMPLATE_DIR."/"."info.html");
define("TEMPLATE_INITIAL", TEMPLATE_DIR."/"."initial.html");

//HTMLテンプレートライブラリ読み込み
require_once(TEMPLATE_LIB);

function config_common_error_exit(){
	global $Page;
	
	$Page["Title"] = "サーバ内部エラー";
	$Page["Message"] = "サーバの内部エラーが発生しました。";
	$Page["Back"] = $_SERVER["PHP_SELF"];
	htmltemplate::t_include(TEMPLATE_INFO,$Page);
	exit();
}

//本スクリプト内からの呼び出し(設定ファイルが無い場合に作成)
function create_default_config(){
	$conf = new Config_Container("section", "album_config");
	
	//アルバム共通項目
	$conf_common = $conf->createSection("COMMON");
	$conf_common->createDirective("album_name", "Piccy Cabinet");
	$conf_common->createDirective("default_template", DEFALUT_TEMPLATE);
	$conf_common->createDirective("version", NOW_VERSION);
	
	//DB関係
	$conf_db = $conf->createSection("DB");
	$conf_db->createDirective("type", "mysql");
	$conf_db->createDirective("host", "localhost");
	$conf_db->createDirective("user", "root");
	$conf_db->createDirective("pass", "pass");
	$conf_db->createDirective("db_name", "photo");
	
	//ログ関係
	$conf_log = $conf->createSection("LOG");
	$conf_log->createDirective("name", INITIAL_LOG_FILE_NAME);
	$conf_log->createDirective("level", INFO);
	$conf_log->createDirective("num", 5);
	$conf_log->createDirective("size", 1048576);
	
	
	//写真関係
	$conf_photo = $conf->createSection("PHOTO");
	//画像格納ディレクトリパス(書き込み権限が必要です)
	$conf_photo->createDirective("save_dir", "/var/photo");
	
	//サムネイル１(一覧表示用)設定
	//高さをそろえるか、幅をそろえるか選択
	//リサイズポリシー fix_widthかfix_heightを選択 
	$conf_photo->createDirective("thumb1_policy", "fix_height");
	//高さを揃える場合(fix_width)に有効　ピクセルで指定
	$conf_photo->createDirective("thumb1_height", "80");
	//幅を揃える場合(fix_height)に有効　ピクセルで指定
	$conf_photo->createDirective("thumb1_width", "100");
	//JPEG画像の圧縮率
	$conf_photo->createDirective("thumb1_comp_rate", "80");
	
	//サムネイル２(拡大表示用)設定
	//リサイズポリシー fix_widthかfix_heightを選択
	$conf_photo->createDirective("thumb2_policy", "fix_width");
	//高さを揃える場合(fix_width)に有効　ピクセルで指定
	$conf_photo->createDirective("thumb2_height", "450");
	//幅を揃える場合(fix_height)に有効　ピクセルで指定
	$conf_photo->createDirective("thumb2_width", "450");
	//JPEG画像の圧縮率
	$conf_photo->createDirective("thumb2_comp_rate", "70");
	
	//サムネイル3(極小サムネイル)設定
	//高さをそろえるか、幅をそろえるか選択
	//リサイズポリシー fix_widthかfix_heightを選択 
	$conf_photo->createDirective("thumb3_policy", "fix_height");
	//高さを揃える場合(fix_width)に有効　ピクセルで指定
	$conf_photo->createDirective("thumb3_height", "40");
	//幅を揃える場合(fix_height)に有効　ピクセルで指定
	$conf_photo->createDirective("thumb3_width", "50");
	//JPEG画像の圧縮率
	$conf_photo->createDirective("thumb3_comp_rate", "60");
	
	//サムネイル4(拡大表示用2)設定
	//リサイズポリシー fix_widthかfix_heightを選択
	$conf_photo->createDirective("thumb4_policy", "fix_width");
	//高さを揃える場合(fix_width)に有効　ピクセルで指定
	$conf_photo->createDirective("thumb4_height", "600");
	//幅を揃える場合(fix_height)に有効　ピクセルで指定
	$conf_photo->createDirective("thumb4_width", "600");
	//JPEG画像の圧縮率
	$conf_photo->createDirective("thumb4_comp_rate", "100");

	//アルバム作成処理関係PHPコマンドライン実行パス
	$conf_php = $conf->createSection("PHP");
	$conf_php->createDirective("mod", "Async");
	$conf_php->createDirective("cmd", "/usr/bin/php");
	$conf_php->createDirective("nul", "/dev/null");
	
	$config = new Config();
	$config->setRoot($conf);
	
	$config->writeConfig(CONFIG_FILE_NAME, "xml",
                     array("encoding" => "utf-8"));
	//エラー処理
	if (PEAR::isError($config)) {
		$Page["ErrMesg"] .= "デフォルト設定ファイルの書き込みに失敗しました。ErrorMessage=".$config->getMessage();
    	return false;
	}
	
	//エラー処理
	update_log_properties(INITIAL_LOG_FILE_NAME,5,1048576,INFO);
	
	return true;
}

//初期化処理時Stpe2で実行　Logモジュール利用可能な状態(ログインはまだ)
function set_initial_config($album_name, $default_template, $db_user, $db_pass, $db_host, $db_name, 
					$log_file_name, $log_level, $log_file_num, $log_file_size, $save_dir, $mod, $cmd, $nul){
	//変更処理
	$config = new Config();
	$xml = $config->parseConfig(CONFIG_FILE_NAME,"XML");
	
	//アルバム共通項目
	$child_common = $xml->searchPath(array("album_config","COMMON"));
	$child_common->setDirective("album_name", cnv_utf8_str($album_name));
	$child_common->setDirective("default_template", $default_template);
	
	//DB関係
	$child_db = $xml->searchPath(array("album_config","DB"));
	$child_db->setDirective("user", $db_user);
	$child_db->setDirective("pass", $db_pass);
	$child_db->setDirective("host", $db_host);
	$child_db->setDirective("db_name", $db_name);
	
	//ログ関係
	$child_log = $xml->searchPath(array("album_config","LOG"));
	$child_log->setDirective("name", $log_file_name);
	$child_log->setDirective("level", $log_level);
	$child_log->setDirective("num", $log_file_num);
	$child_log->setDirective("size", $log_file_size);
	
	//写真関係
	$child_photo = $xml->searchPath(array("album_config","PHOTO"));
	$child_photo->setDirective("save_dir", $save_dir);
	
	//アルバム作成処理関係PHPコマンドライン実行パス
	$child_php = $xml->searchPath(array("album_config","PHP"));
	$child_php->setDirective("mod",  $mod);
	$child_php->setDirective("cmd", $cmd);
	$child_php->setDirective("nul", $nul);
	
	//設定ファイル書き込み
	$config->writeConfig(CONFIG_FILE_NAME, "XML",
	                     array("encoding" => "utf-8"));

	//エラー処理
	if (PEAR::isError($config)) {
		$Page["ErrMesg"] .= "デフォルト設定ファイルの書き込みに失敗しました。ErrorMessage=".$config->getMessage();
    	return false;
	}
	
	//エラー処理
	update_log_properties($log_file_name,$log_file_num,$log_file_size,$log_level);
	
	return true;
}

//バージョン情報変更処理時実行
function change_config_version($version){

	//変更処理
	$config = new Config();
	$xml = $config->parseConfig(CONFIG_FILE_NAME,"XML");
	
	//アルバム共通項目
	$child_common = $xml->searchPath(array("album_config","COMMON"));
	$child_common->setDirective("version", cnv_utf8_str($version));
	
	//設定ファイル書き込み
	$config->writeConfig(CONFIG_FILE_NAME, "XML",
	                     array("encoding" => "UTF-8"));

	//エラー処理
	if (PEAR::isError($config)) {
    	return false;
	}
	return true;
}

//alpha-02への更新時に実行
function update_config_01(){
	
	//変更処理
	$config = new Config();
	$xml = $config->parseConfig(CONFIG_FILE_NAME,"XML");
	
	//アルバム共通項目
	$child_photo = $xml->searchPath(array("album_config","PHOTO"));
	$child_photo->setDirective("thumb3_policy", "fix_height");
	$child_photo->setDirective("thumb3_height", "40");
	$child_photo->setDirective("thumb3_width", "50");
	$child_photo->setDirective("thumb3_comp_rate", "60");
	
	$child_photo->setDirective("thumb4_policy", "fix_width");
	$child_photo->setDirective("thumb4_height", "600");
	$child_photo->setDirective("thumb4_width", "600");
	$child_photo->setDirective("thumb4_comp_rate", "100");

	//設定ファイル書き込み
	$config->writeConfig(CONFIG_FILE_NAME, "XML",
	                     array("encoding" => "UTF-8"));

	//エラー処理
	if (PEAR::isError($config)) {
    	return false;
	}
	return true;
	
}

//0.1.01への更新時実行
function update_config_02(){
	
	//変更処理
	$config = new Config();
	$xml = $config->parseConfig(CONFIG_FILE_NAME,"XML");
	
	//アルバム共通項目
	$child_php = $xml->searchPath(array("album_config","PHP"));
	$child_php->setDirective("mod",  "Async");

	//設定ファイル書き込み
	$config->writeConfig(CONFIG_FILE_NAME, "XML",
	                     array("encoding" => "UTF-8"));

	//エラー処理
	if (PEAR::isError($config)) {
    	return false;
	}
	return true;
	
}

//構成情報変更処理時実行
function change_config($album_name, $default_template, 
		$thumb1_policy, $thumb1_height, $thumb1_width, $thumb1_comp_rate, 
		$thumb2_policy, $thumb2_height, $thumb2_width, $thumb2_comp_rate, 
		$thumb3_policy, $thumb3_height, $thumb3_width, $thumb3_comp_rate, 
		$thumb4_policy, $thumb4_height, $thumb4_width, $thumb4_comp_rate,
		$log_file_name, $log_level, $log_file_num, $log_file_size, 
		$mod, $cmd, $nul){
	//変更処理
	$config = new Config();
	$xml = $config->parseConfig(CONFIG_FILE_NAME,"XML");
	
	//アルバム共通項目
	$child_common = $xml->searchPath(array("album_config","COMMON"));
	$child_common->setDirective("album_name", cnv_utf8_str($album_name));
	$child_common->setDirective("default_template", $default_template);
	
	//写真関係
	$child_photo = $xml->searchPath(array("album_config","PHOTO"));
	$child_photo->setDirective("thumb1_policy", $thumb1_policy);
	$child_photo->setDirective("thumb1_height", $thumb1_height);
	$child_photo->setDirective("thumb1_width", $thumb1_width);
	$child_photo->setDirective("thumb1_comp_rate", $thumb1_comp_rate);
	
	$child_photo->setDirective("thumb2_policy", $thumb2_policy);
	$child_photo->setDirective("thumb2_height", $thumb2_height);
	$child_photo->setDirective("thumb2_width", $thumb2_width);
	$child_photo->setDirective("thumb2_comp_rate", $thumb2_comp_rate);
	
	$child_photo->setDirective("thumb3_policy", $thumb3_policy);
	$child_photo->setDirective("thumb3_height", $thumb3_height);
	$child_photo->setDirective("thumb3_width", $thumb3_width);
	$child_photo->setDirective("thumb3_comp_rate", $thumb3_comp_rate);
	
	$child_photo->setDirective("thumb4_policy", $thumb4_policy);
	$child_photo->setDirective("thumb4_height", $thumb4_height);
	$child_photo->setDirective("thumb4_width", $thumb4_width);
	$child_photo->setDirective("thumb4_comp_rate", $thumb4_comp_rate);
	
	//ログ関係
	$child_log = $xml->searchPath(array("album_config","LOG"));
	$child_log->setDirective("name", $log_file_name);
	$child_log->setDirective("level", $log_level);
	$child_log->setDirective("num", $log_file_num);
	$child_log->setDirective("size", $log_file_size);
	
	//アルバム作成処理関係PHPコマンドライン実行パス
	$child_php = $xml->searchPath(array("album_config","PHP"));
	$child_php->setDirective("mod",  $mod);
	$child_php->setDirective("cmd", $cmd);
	$child_php->setDirective("nul", $nul);
	
	//設定ファイル書き込み
	$config->writeConfig(CONFIG_FILE_NAME, "XML",
	                     array("encoding" => "UTF-8"));

	//エラー処理
	if (PEAR::isError($config)) {
		$Page["ErrMesg"] .= "デフォルト設定ファイルの書き込みに失敗しました。ErrorMessage=".$config->getMessage();
    	return false;
	}
	
	//エラー処理
	update_log_properties($log_file_name,$log_file_num,$log_file_size,$log_level);
	
	return true;
}

if(!file_exists(CONFIG_FILE_NAME)){
	if(!create_default_config()){
		config_common_error_exit();
	}
}

function initial_parse_config(){
	global $ConfigArray;
	
	$config = new Config();
	$xml = $config->parseConfig(CONFIG_FILE_NAME,"XML",
	                     array("encoding" => "utf-8"));
	if (PEAR::isError($xml)) {
	    $Page["ErrMesg"] .= "コンフィグ情報の読み込みに失敗しました。".$xml->getMessage();
	    config_common_error_exit();
	}
	$ConfigArray = $xml->toArray();
}

function update_log_properties($log_file_name,$log_file_num,$log_file_size,$log_level){
	if(!($fp = fopen("log4php.properties", "w"))){
		return false;
	}
	
	switch ($log_level) {
		case INFO:
			$log_level_string = "INFO";
			break;
		case WARNING:
			$log_level_string = "WARN";
			break;
		case DEBUG:
			$log_level_string = "DEBUG";
			break;
		case ERROR:
			$log_level_string = "ERROR";
			break;
		default:
			$log_level_string = "FATAL";
	}
	
	flock($fp, LOCK_EX);
	fwrite($fp, "#---------------------------------");
	fwrite($fp, "\n");
	fwrite($fp, "# Setting for Piccy-Cabinet logger");
	fwrite($fp, "\n");
	fwrite($fp, "#  create date:".now_time());
	fwrite($fp, "\n");
	fwrite($fp, "#---------------------------------");
	fwrite($fp, "\n");
	fwrite($fp, "log4php.rootLogger=".$log_level_string.",file");
	fwrite($fp, "\n");
	fwrite($fp, "log4php.appender.file=LoggerAppenderRollingFile");
	fwrite($fp, "\n");
	fwrite($fp, "log4php.appender.file.Append=true");
	fwrite($fp, "\n");
	fwrite($fp, "log4php.appender.file.file=./log/".$log_file_name.".log");
	fwrite($fp, "\n");
	fwrite($fp, "log4php.appender.file.layout=LoggerPatternLayout");
	fwrite($fp, "\n");
	fwrite($fp, "log4php.appender.file.layout.ConversionPattern=\"%d %5p [%X{REMOTE_ADDR}] - %m%n\"");
	fwrite($fp, "\n");
	fwrite($fp, "log4php.appender.file.MaxFileSize=".$log_file_size);
	fwrite($fp, "\n");
	fwrite($fp, "log4php.appender.file.MaxBackupIndex=".$log_file_num);
	fwrite($fp, "\n");
	flock($fp, LOCK_UN);
	fclose($fp);
	
	return true;
}

initial_parse_config();
?>
